#include <iostream>
#include <stdio.h>
#include <stdlib.h>

#define N 16
#define amis_max 12

int constr[amis_max];//l'ami i demande la pizza constr[i]
int care[amis_max];// le bit j de care[i] dit si l'ami i a un avis sur l'ingrdient j
int amis;//le nombre d'amis
int sur_plus;//le bit j de sur_plus dit si on est sr de mettre l'ingrdient j sur la pizza
int sur_moins;//le bit j de sur_plus dit si on est sr de ne pas mettre l'ingrdient j sur la pizza

void init()//on initialise avant chaque nouveau problme
{
  amis=0;//on remet le nombre d'amis  0
  sur_plus=0;
  sur_moins=0;
  for(int i=0;i<amis_max;i++)//on remet  0 les tableaux de contraintes
  {
		constr[i]=0;
		care[i]=0;
  }
}

bool test(int n)//renvoie vrai ssi la pizza associe  n est accepte par tous les amis
{
  for(int i=0;i<amis;i++)//pour chaque ami
	{
		/*
		constr[i]&n donne les ingrdients prsents sur la pizza et demands par l'ami i
		~constr[i]&~n donne les ingrdients absents de la pizza teste et de celle demande par l'ami i
		(constr[i]&n | ~constr[i]&~n) donne les points communs entre la pizza teste et celle demande
		(care[i]&(constr[i]&n | ~constr[i]&~n))=0 <=> aucune contrainte n'est satisfaite par la pizza
		*/
		if(not(care[i]&(constr[i]&n | ~constr[i]&~n)))
			return false;
	}
  return true;// <=> tous les amis sont satisfaits
}

void affiche(int n)//affiche la pizza associe  n
{
  std::cout<<"Toppings: ";
  for(int i=0;i<N;i++)//pour chaque ingrdient
    {
      if(n&(1<<i))// <=> l'ingrdient i est sur la pizza
				std::cout<<char ('A'+i);
    }
  std::cout<<'\n';
}

int main()
{
  int tmp;//retient le caractre prcdent si c'est un + ou un -
  int n;//le  numro de la pizza
  int c;//le caractre lu
	int utile;//retient tous les ingrdients demands positivement
  bool possible;//possible=false <=> les contraintes ne sont pas satisfiables
  int p=0;//le nombre de contraintes donnes par l'ami en cours de lecture
  while(not feof(stdin))//tant que l'on est pas  la fin du fichier
  {
		init();//on initialise
		possible=true;
		utile=0;
		c=getchar();
		while(c!='.')//pour chaque srie de contraintes
		{
			if(c=='+')
				tmp=1;//on retient 1 si on a un +
			else if(c=='-')
				tmp=0;//on retient 0 si on a un -
			else if(c==';')//on change d'ami lorsque l'on trouve un ;
			{
				possible=possible && ((constr[amis]& ~sur_moins)|((constr[amis]^care[amis])& ~sur_plus));
				if(p==1 && possible)//s'il ne donne qu'une contrainte et qu'elle est possible
				{
					sur_plus=sur_plus|constr[amis];//on en tient compte dans sur_plus et sur_moins
					sur_moins=sur_moins|(care[amis]^constr[amis]);
				}
				p=0;//on remet  0 avant de changer d'ami
				utile=utile|constr[amis];//on compte les ingrdients cits positivement
				amis++;//on passe  l'ami suivant
			}
			else if(c<='P' && c>='A')//si c est un ingrdient
			{
				constr[amis]+=tmp*(1<<(c-'A'));//on retient la contrainte dans l'entier
				care[amis]+=1<<(c-'A');
				p++;//on compte le nombre de contraintes donnes par l'ami en cours de lecture
			}
			else if(feof(stdin))//si on est  la fin
			{
				return 0;//on stoppe
			}
			c=getchar();
		}
		sur_moins=sur_moins|~utile;//on tient compte des ingrdients inusits
		if(possible)//on recalcule possible avec toutes les certitudes
			for(int i=0;i<amis;i++)//pour chaque ami
				possible=possible && ((constr[i]& ~sur_moins)|((constr[i]^care[i])& ~sur_plus));
		if(possible)
		{
			for(n=0;n<65536;n++)//on teste toutes les pizzas
			{
				n=(n|sur_plus);//on impose les plus
				n+=(n&sur_moins);//on passe si on veut un moins
				if(test(n))//si la pizza convient  tout le monde
				{
					affiche(n);
					break;//on arte la recherche de pizzas
				}
			}
		}
		if(n==65536 || not possible)//si on a test toutes les pizzas ou que ce n'est pas possible d'en trouver une
			std::cout<<"No pizza can satisfy these requests.\n";
	}
}
